const React = require('react');
const DropDownMenu = require('./DropDownMenu.js');
const ListSortSettingsWindow = require('./ListSortSettingsWindow.js');
const MailSettingsWindow = require('./MailSettingsWindow.js');

var dropdown_account = React.createElement(
    DropDownMenu, {
        id: 'account',
        items: [ {
            icon: 'mail_unread',
            i16: true,
            text: 'Read vitalif@mail.ru'
        }, {
            icon: 'folder',
            text: 'IMAP Folders',
        }, {
            icon: 'properties',
            text: 'Properties...'
        } ]
    }
);

var dropdown_reply = React.createElement(
    DropDownMenu, {
        id: 'reply',
        items: [ {
            hotkey: 'R',
            icon: 'mail_reply',
            text: 'Reply'
        }, {
            icon: 'mail_reply',
            text: 'Reply to Sender',
        }, {
            disabled: true,
            icon: 'mail_reply_all',
            text: 'Reply to List'
        } ]
    }
);

var dropdown_forward = React.createElement(
    DropDownMenu, {
        id: 'forward',
        items: [ {
            hotkey: 'F',
            icon: 'mail_forward',
            text: 'Reply'
        }, {
            hotkey: 'D',
            text: 'Redirect'
        } ]
    }
);

var dropdown_delete = React.createElement(
    DropDownMenu, {
        id: 'delete',
        items: [ {
            text: 'Move to Trash'
        }, {
            icon: 'delete',
            text: 'Delete Permanently'
        } ]
    }
);

var dropdown_check_send = React.createElement(
    DropDownMenu, {
        id: 'check-send',
        items: [ {
            hotkey: 'Ctrl-K',
            icon: 'mail_check',
            text: 'Check All'
        }, {
            hotkey: 'Ctrl-Shift-K',
            icon: 'mail_send',
            text: 'Send Queued'
        }, { split: true }, {
            icon: 'mail_check',
            text: 'vitalif@mail.ru'
        }, {
            icon: 'mail_check',
            text: 'vitalif@yourcmc.ru'
        }, { split: true }, {
            text: 'Resynchronize All Messages'
        } ]
    }
);

var dropdown_threads = React.createElement(
    DropDownMenu, {
        id: 'threads',
        items: [ {
            icon: 'thread',
            text: 'Show Message Thread'
        }, {
            text: 'Follow Thread'
        }, {
            text: 'Ignore Thread'
        }, { split: true }, {
            hotkey: 'M',
            icon: 'read',
            text: 'Mark Thread as Read'
        }, { split: true }, {
            hotkey: 'N',
            text: 'Mark Thread and Go to Next Unread'
        } ]
    }
);

var dropdown_list_sort = React.createElement(
    ListSortSettingsWindow, {
        id: 'list-sort',
        window: true,
        folder: 'INBOX',
        override: false,
        sorting: {},
        defaultSorting: {
            sort: {
                sortby: 'sent date',
                group: 'date',
                ascending: false,
                threaded: false
            }
        },
        show: {
            read: true,
            trash: false,
            spam: false,
            lists: true,
            sent: true,
            dups: true
        }
    }
);

var dropdown_settings = MailSettingsWindow;

module.exports = function()
{
    return [
        dropdown_account,
        dropdown_reply,
        dropdown_forward,
        dropdown_delete,
        dropdown_check_send,
        dropdown_threads,
        dropdown_list_sort,
        dropdown_settings
    ];
}
