function getOffset(elem)
{
    if (elem.getBoundingClientRect)
    {
        var box = elem.getBoundingClientRect();
        var body = document.body;
        var docElem = document.documentElement;
        var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop;
        var scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;
        var clientTop = docElem.clientTop || body.clientTop || 0;
        var clientLeft = docElem.clientLeft || body.clientLeft || 0;
        var top = box.top + scrollTop - clientTop;
        var left = box.left + scrollLeft - clientLeft;
        return { top: Math.round(top), left: Math.round(left) };
    }
    else
    {
        var top = 0, left = 0;
        while(elem)
        {
            top = top + parseInt(elem.offsetTop);
            left = left + parseInt(elem.offsetLeft);
            elem = elem.offsetParent;
        }
        return { top: top, left: left };
    }
}

var DropDownBase = module.exports = {
    instances: {},
    currentVisible: null,
    componentDidMount: function()
    {
        if (!DropDownBase.setBodyListener)
        {
            window.addEventListener('click', DropDownBase.hideAll);
            window.addEventListener('resize', DropDownBase.repositionCurrent);
            DropDownBase.setBodyListener = true;
        }
        DropDownBase.instances[this.props.id] = this;
    },
    hideAll: function()
    {
        for (var i in DropDownBase.instances)
            DropDownBase.instances[i].hide();
    },
    repositionCurrent: function()
    {
        if (DropDownBase.currentVisible)
            DropDownBase.currentVisible[0].showAt(DropDownBase.currentVisible[1], DropDownBase.currentVisible[0].onClose);
    },
    componentWillUnmount: function()
    {
        delete DropDownBase.instances[this.props.id];
        if (DropDownBase.currentVisible[0] == this)
            DropDownBase.currentVisible = null;
    },
    getInitialState: function()
    {
        return { visible: false, top: 0, left: 0, calloutLeft: null, selectedItem: -1 };
    },
    onClick: function(ev)
    {
        ev.stopPropagation();
    },
    isVisible: function()
    {
        return this.state.visible;
    },
    hide: function()
    {
        this.setState({ visible: false });
        DropDownBase.currentVisible = null;
        if (this.onClose)
        {
            this.onClose();
            delete this.onClose;
        }
    },
    showAt: function(el, onClose)
    {
        if (this.onClose && this.onClose != onClose)
        {
            this.onClose();
            delete this.onClose;
        }
        DropDownBase.currentVisible = [ this, el ];
        var p = getOffset(el);
        var left = p.left, top = p.top+el.offsetHeight, calloutLeft = null;
        this.setState({ visible: true, top: top, left: left, selectedItem: -1 });
        this.refs.dd.style.display = 'block';
        if (this.props.window)
        {
            left = Math.round(p.left+el.offsetWidth/2-this.refs.dd.offsetWidth/2);
            top = p.top+el.offsetHeight+3;
        }
        var ww = window.innerWidth  || de.clientWidth  || db.clientWidth;
        var wh = window.innerHeight || de.clientHeight || db.clientHeight;
        if (left + this.refs.dd.offsetWidth > ww)
        {
            left = ww-this.refs.dd.offsetWidth;
            calloutLeft = Math.round(p.left+el.offsetWidth/2-left);
        }
        if (top + this.refs.dd.offsetHeight > wh)
            top = wh-this.refs.dd.offsetHeight;
        this.refs.dd.style.display = '';
        this.setState({ visible: true, top: top, left: left, calloutLeft: calloutLeft });
        this.refs.dd.focus();
        this.onClose = onClose;
    }
};
