var WeekDays = module.exports.WeekDays = [ 'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat' ];
var Months = module.exports.Months = [ 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' ];

module.exports.formatBytes = function(s)
{
    if (!s) return '';
    if (s < 1024) return s+' B';
    else if (s < 1024*1024) return (Math.round(s*10/1024)/10)+' KB';
    else if (s < 1024*1024*1024) return (Math.round(s*10/1024/1024)/10)+' MB';
    return (Math.round(s*10/1024/1024/1024)/10)+' GB';
}

module.exports.formatDate = function(dt)
{
    if (!(dt instanceof Date))
        dt = new Date(dt.replace(' ', 'T'));
    var tod = new Date();
    tod.setHours(0);
    tod.setMinutes(0);
    tod.setSeconds(0);
    tod.setMilliseconds(0);
    var prevweek = tod;
    prevweek = prevweek.getTime() - (7 + (prevweek.getDay()+6)%7)*86400000;
    if (dt.getTime() < prevweek)
    {
        var d = dt.getDate();
        var m = dt.getMonth()+1;
        return (d < 10 ? '0' : '')+d+'.'+(m < 10 ? '0' : '')+m+'.'+dt.getFullYear();
    }
    else if (dt.getTime() < tod.getTime())
    {
        return WeekDays[dt.getDay()]+' '+dt.getDate()+' '+Months[dt.getMonth()];
    }
    var h = dt.getHours();
    var m = dt.getMinutes();
    return (h < 10 ? '0' : '')+h+':'+(m < 10 ? '0' : '')+m;
}

module.exports.getGroupName = function(k)
{
    if (k == 't')
    {
        return 'Today';
    }
    else if (k[0] == 'd')
    {
        return WeekDays[k.substr(1)%7];
    }
    else if (k == 'pw')
    {
        return 'Last Week';
    }
    else if (k[0] == 'm')
    {
        return Months[k.substr(1)-1];
    }
    return k;
}
