const React = require('react');
const ReactDOM = require('react-dom');
const ComposeWindow = require('./ComposeWindow.js');
const FolderList = require('./FolderList.js');
const MessageList = require('./MessageList.js');
const MessageView = require('./MessageView.js');
const TabPanel = require('./TabPanel.js');
const Store = require('./Store.js');
const StoreListener = require('./StoreListener.js');
const AllDropdowns = require('./AllDropdowns.js');

window.requestAnimationFrame = window.requestAnimationFrame || window.mozRequestAnimationFrame;

var AllTabs = StoreListener(TabPanel, function(data)
{
    return { tabs: [
        {
            className: data.layout,
            noclose: true,
            icon: 'mail_unread',
            title: 'Unread (64)',
            children: [ MessageList, MessageView ]
        },
        {
            icon: 'mail_drafts',
            i16: true,
            title: 'Compose Message',
            children: [ ComposeWindow ]
        }
    ] }
});

ReactDOM.render(
    <div>
        {AllDropdowns()}
        <FolderList />
        {AllTabs}
    </div>,
    document.body
);

Store.loadAccounts();
